// ======================================================================== //
// Copyright 2009-2018 Intel Corporation                                    //
//                                                                          //
// Licensed under the Apache License, Version 2.0 (the "License");          //
// you may not use this file except in compliance with the License.         //
// You may obtain a copy of the License at                                  //
//                                                                          //
//     http://www.apache.org/licenses/LICENSE-2.0                           //
//                                                                          //
// Unless required by applicable law or agreed to in writing, software      //
// distributed under the License is distributed on an "AS IS" BASIS,        //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. //
// See the License for the specific language governing permissions and      //
// limitations under the License.                                           //
// ======================================================================== //

#pragma once

#include "../common/scene_instance.h"
#include "../common/ray.h"

namespace embree
{
  namespace isa
  {
    struct FastInstanceIntersectorN
    {
      static void intersect1(const struct RTCIntersectFunctionNArguments* const args);
      static void occluded1 (const struct RTCOccludedFunctionNArguments* const args);

      template<int N> static void intersectN(const struct RTCIntersectFunctionNArguments* const args);
      template<int N> static void occludedN (const struct RTCOccludedFunctionNArguments* const args);
   
      static void intersect(const struct RTCIntersectFunctionNArguments* const args);
      static void occluded (const struct RTCOccludedFunctionNArguments* const args);
    };
  }
}
